<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_OrderedPrice1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_OrderedPrice1 extends AbstractStructArrayBase
{
    /**
     * The ChildrenA
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_OrderedPrice[]
     */
    public $ChildrenA;
    /**
     * Constructor method for ArrayOfJPSOAP_OrderedPrice1
     * @uses ArrayOfJPSOAP_OrderedPrice1::setChildrenA()
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenA
     */
    public function __construct(array $childrenA = array())
    {
        $this
            ->setChildrenA($childrenA);
    }
    /**
     * Get ChildrenA value
     * @return \StructType\JPSOAP_OrderedPrice[]|null
     */
    public function getChildrenA()
    {
        return $this->ChildrenA;
    }
    /**
     * This method is responsible for validating the values passed to the setChildrenA method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChildrenA method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChildrenAForArrayConstraintsFromSetChildrenA(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_OrderedPrice1ChildrenAItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_OrderedPrice1ChildrenAItem instanceof \StructType\JPSOAP_OrderedPrice) {
                $invalidValues[] = is_object($arrayOfJPSOAP_OrderedPrice1ChildrenAItem) ? get_class($arrayOfJPSOAP_OrderedPrice1ChildrenAItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_OrderedPrice1ChildrenAItem), var_export($arrayOfJPSOAP_OrderedPrice1ChildrenAItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChildrenA property can only contain items of type \StructType\JPSOAP_OrderedPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChildrenA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenA
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice1
     */
    public function setChildrenA(array $childrenA = array())
    {
        // validation for constraint: array
        if ('' !== ($childrenAArrayErrorMessage = self::validateChildrenAForArrayConstraintsFromSetChildrenA($childrenA))) {
            throw new \InvalidArgumentException($childrenAArrayErrorMessage, __LINE__);
        }
        $this->ChildrenA = $childrenA;
        return $this;
    }
    /**
     * Add item to ChildrenA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice $item
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice1
     */
    public function addToChildrenA(\StructType\JPSOAP_OrderedPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_OrderedPrice) {
            throw new \InvalidArgumentException(sprintf('The ChildrenA property can only contain items of type \StructType\JPSOAP_OrderedPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChildrenA[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildrenA
     */
    public function getAttributeName()
    {
        return 'ChildrenA';
    }
}
